package ru.dbotthepony.kstarbound.defs

import com.google.gson.stream.JsonWriter
import ru.dbotthepony.kstarbound.json.builder.IStringSerializable

enum class EntityType(val jsonName: String) : IStringSerializable {
	PLAYER("PlayerEntity"),
	MONSTER("MonsterEntity"),
	OBJECT("ObjectEntity"),
	ITEM_DROP("ItemDropEntity"),
	PROJECTILE("ProjectileEntity"),
	PLANT("PlantEntity"),
	PLANT_DROP("PlantDropEntity"), // wat
	NPC("NpcEntity"),
	STAGEHAND("StagehandEntity"),
	VEHICLE("VehicleEntity");

	override fun match(name: String): Boolean {
		return name == jsonName
	}

	override fun write(out: JsonWriter) {
		out.name(jsonName)
	}
}
