package ru.dbotthepony.kstarbound.network.packets

import it.unimi.dsi.fastutil.ints.Int2ObjectAVLTreeMap
import it.unimi.dsi.fastutil.ints.Int2ObjectMap
import ru.dbotthepony.kommons.io.readByteArray
import ru.dbotthepony.kommons.io.readSignedVarInt
import ru.dbotthepony.kommons.io.readVarInt
import ru.dbotthepony.kommons.io.writeByteArray
import ru.dbotthepony.kommons.io.writeSignedVarInt
import ru.dbotthepony.kommons.io.writeVarInt
import ru.dbotthepony.kstarbound.client.ClientConnection
import ru.dbotthepony.kstarbound.network.IClientPacket
import ru.dbotthepony.kstarbound.network.IServerPacket
import ru.dbotthepony.kstarbound.server.ServerConnection
import java.io.DataInputStream
import java.io.DataOutputStream

class EntityUpdateSetPacket(val forConnection: Int, val deltas: Int2ObjectMap<ByteArray>) : IServerPacket, IClientPacket {
	override fun write(stream: DataOutputStream, isLegacy: Boolean) {
		stream.writeVarInt(forConnection)
		stream.writeVarInt(deltas.size)

		for ((k, v) in deltas.entries) {
			stream.writeSignedVarInt(k)
			stream.writeByteArray(v)
		}
	}

	override fun play(connection: ServerConnection) {

	}

	override fun play(connection: ClientConnection) {
		TODO("Not yet implemented")
	}

	companion object {
		fun read(stream: DataInputStream, isLegacy: Boolean): EntityUpdateSetPacket {
			val forConnection = stream.readVarInt()
			val size = stream.readVarInt()

			val deltas = Int2ObjectAVLTreeMap<ByteArray>()

			for (i in 0 until size) {
				val k = stream.readSignedVarInt()
				val v = stream.readByteArray()
				deltas[k] = v
			}

			return EntityUpdateSetPacket(forConnection, deltas)
		}
	}
}